package dk.topsecurity.businessdelegate;

import java.util.List;

import org.apache.commons.logging.*; //Log,LogFactory
import dk.topsecurity.springdao.*;
import dk.topsecurity.hibernate.*;


/**
 * Business delegate layer to seperate DAO from web presentation
 * according to http://www.corej2eepatterns.com/Patterns2ndEd/BusinessDelegate.htm
 */
public class AttributeManagerImpl implements AttributeManager {
    private static Log log = LogFactory.getLog(AttributeManagerImpl.class);
    private AttributeDAO dao;

    public void setAttributeDAO(AttributeDAO newDao) { dao = newDao; }

    public List getAttributes() { return dao.getAttributes(); }

    public boolean existAttribute(String attributeName) { return dao.existAttribute(attributeName); }

    public Attribute getAttribute(String attributeId) {
        Attribute attribute = dao.getAttribute(Long.valueOf(attributeId));

        if (attribute == null) {
            log.warn("AttributeId '" + attributeId + "' not found in database.");
        }

        return attribute;
    }

    public Attribute saveAttribute(Attribute attribute) {
        dao.saveAttribute(attribute);
        return attribute;
    }

    public void removeAttribute(String attributeId) {  dao.removeAttribute(Long.valueOf(attributeId)); }
}
