package dk.topsecurity.hibernate;

import java.io.Serializable;
import org.apache.commons.lang.builder.*; //EqualsBuilder,HashCodeBuilder,ToStringBuilder,ToStringStyle

/**
 * Template for objects offering toString, equals and hashCode methods.
 * Follows rules laid out in the book Effective Java by Joshua Bloch. 
 * Writing a good hashCode method is actually quite difficult. 
 * This class aims to simplify the process.
 *
 */
public class JoshuaBlochBaseObject implements Serializable {

    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE); }

    public boolean equals(Object obj) { return EqualsBuilder.reflectionEquals(this, obj); }

    public int hashCode() { return HashCodeBuilder.reflectionHashCode(this); }

}
