package dk.topsecurity.springdao;

import java.util.List;

import org.apache.commons.logging.*;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;
import org.hibernate.Hibernate;

import dk.topsecurity.hibernate.*;


/**
 * DAO object according to
 * http://java.sun.com/blueprints/corej2eepatterns/Patterns/DataAccessObject.html
 */
public class AttributeDAOImpl extends HibernateDaoSupport implements AttributeDAO {
    private static Log log = LogFactory.getLog(AttributeDAOImpl.class);

    public List getAttributes() { return getHibernateTemplate().find("from Attribute"); }

     //http://www.springframework.org/docs/api/org/springframework/orm/hibernate3/HibernateTemplate.html
    public boolean existAttribute(String attributeName) { 
      List l = getHibernateTemplate().find("from Attribute where name=?", attributeName); 
      return (l!=null && l.size()!=0);
    }

    public Attribute getAttribute(Long attribId) { return (Attribute) getHibernateTemplate().get(Attribute.class, attribId); }

    public void saveAttribute(Attribute attrib) {
        getHibernateTemplate().saveOrUpdate(attrib);
        log.debug("attributeId set to: " + attrib.getId());
    }

    public void removeAttribute(Long attribId) { 
      try {
        getHibernateTemplate().delete( getHibernateTemplate().load(Attribute.class, attribId) ); 
      }
      catch(Throwable tr) {
         log.error("Hibernate failed to delete entry: ");
         tr.printStackTrace();
      }
    }
}
